;***************************************************************
;
;       device select
;
;***************************************************************

;R5F10Y1 	.SET 1 			; 10 pins

R5F10Y4 	.SET 1 			; 16 pins

;***************************************************************
;
;       clock definitions
;
;***************************************************************
PLAY_TIME	.EQU	5		; 5minutes

CLKFREQ         .EQU	20000		; kHz(=20MHz)
PERIOD		.EQU	10		; refresh period is 10ms
ROWS		.EQU	8		; Rows in display
TIMEINT		.EQU	250		; 0.25sec for display change

SWTIMING	.EQU	5		; SW check timing (10ms*5)
MASKINIT	.EQU	0x1F		; mask for random number

COUNT		.SET	CLKFREQ*PERIOD/ROWS ; count for row timing
TPSDATA		.SET	0xF0
TDRDT01		.SET	TIMEINT*10/16-1	; count for 1.6ms

TDRDT02		.SET	TDRDT01/4	; fastest timing is 0.0625sec


$IF COUNT >= 0x10000
TPSDATA		.SET	TPSDATA+1	; more than 10000H
COUNT		.SET	COUNT/2
$ENDIF

$IF COUNT >= 0x10000			; more than 20000H
TPSDATA		.SET	TPSDATA+1
COUNT		.SET	COUNT/2
$ENDIF

$IF COUNT >= 0x10000			; more than 40000H
TPSDATA		.SET	TPSDATA+1
COUNT		.SET	COUNT/2
$ENDIF

$IF COUNT >= 0x10000			; more than 80000H
TPSDATA		.SET	TPSDATA+1
COUNT		.SET	COUNT/2
$ENDIF

$IF COUNT >= 0x10000			; more than 100000H
TPSDATA		.SET	TPSDATA+1
COUNT		.SET	COUNT/2
$ENDIF

COUNT		.SET	COUNT - 1	; adjust
