;************************************************************************
;************************************************************************
;
;	Renesas Electronics     RL78/G10
;
;	CPU	: R5F10Y46
;
;	Clock	: 20MHz
;		Clock Selection: 20MHz
;		Minimum Instruction Execution Time:0.050usec
;
;	Supply Volt. : VDD = 4.5V (@20MHz)
;
;************************************************************************

;************************************************************************
;
; File name : opt.asm
; Version   : Ver 1.0
; program   : `R
;yz
; Ver 1.0   : 06/05/2015  VK쐬 
; Ver 1.1   : 06/08/2015  WDT @\ǉgp
;
;************************************************************************

;************************************************************************
;
;	for device name and timing definition
;
;************************************************************************

$INCLUDE	(DEV_CH.inc)

;************************************************************************
;
;	option byte definition
;
;************************************************************************
OPT	.CSEG	OPT_BYTE
	.DB	0b11111101	; WDT function
;		  +++|||||--------must be 1
;		     |||||
;		     ||||+--------WDSTBYON
;		     ||||	1 : stop WDT when in  HALT/STOP mode
;		     ||||
;		     |+++---------WDCS2-0(WDT overflow time )
;		     |		110 : (2^14-1)/fIL
;		     |
;		     +------------WDTON(operation of WDT)
;				1 : use WDT

	.DB	0b11100111	; LVD and RESET pin function
;		  +++|||++--------LVIMDS1-0
;		     |||	11 : reset mode
;		     |||
;		     |++----------SPORS1-0(LVD detect voltage)
;		     |		01 : 2.88V
;		     |
;		     +------------PORTSELB(usage of RESET/P125 pin)
;				0 : P125 pin

	.DB	0b11111001	; HOCO and operarion mode
;		  +++++|||--------must be 1
;		       |||
;		       +++--------FRQSEL3-0(HOCO frequency)
;				001 : 20MHz

$IFDEF R5F10Y1
	.DB	0b00000101	; onchip debug option
;		  |++++|+|--------must be 0
;		  |    +-+--------must be 1
;		  |
;		  +---------------OCDENSET
;		  		0 : Disable OCD

$ELSEIF R5F10Y4
	.DB	0b10000101	; onchip debug option
;		  |++++|+|--------must be 0
;		  |    +-+--------must be 1
;		  |
;		  +---------------OCDENSET
;				1 : Enable OCD

$ENDIF
	END
