;************************************************************************
;************************************************************************
;
;	Renesas Electronics     RL78/G10
;
;	CPU	: R5F10Y46
;
;	Clock	: 20MHz
;		Clock Selection: 20MHz
;		Minimum Instruction Execution Time:0.050usec
;
;	Supply Volt. : VDD = 4.5V (@20MHz)
;
;************************************************************************
;========================================================================
;=									=
;=	4~8}gNXLED\̉pP					=
;=									=
;=	̃Q[̍쐬						=
;=									=
;=	4LED̏㑤[Ō܂^C~Oŕ\Ă	=
;=	̕\ԉ̍sɓBƂɂ̂̃{^B	=
;=	܂Ɠ_ZAԉ\ĂȂƂ	=
;=	ƁA_āAG[LED_łB			=
;=	_炩ߒ߂ꂽ_ɂȂƁA_LED_A	=
;=	Xs[hȂB					=
;=									=
;=									=
;========================================================================

;************************************************************************
;
; File name : r_main.asm
; Version   : Ver 1.2
; program   : `R
;yz
; Ver 1.0   : 06/05/2015  VK쐬 
; Ver 1.1   : 06/08/2015  WDT(Ԑj@\ǉ
; Ver 1.2   : 06/10/2015  Q[ɓՓxǉAZNgʒǉ
; Ver 1.3   : 06/15/2015  Xe[^X\LED̍\ύX
;
;************************************************************************

;************************************************************************
;
;	for device name and timing definition
;
;************************************************************************

$INCLUDE	(DEV_CH.inc)

;************************************************************************
;
;	End of device name definition
;
;************************************************************************


.PUBLIC		main		; to start from initilize routine
.PUBLIC		TDR01DATA	; move timer data

;************************************************************************
;
;	data definition
;
;************************************************************************
DMAIN		.DSEG	SADDRP

TDR01DATA:	.DS	2		; move timer data

POINTTABLE:	.DS	12		; level table
TM01TABLE:	.DS	12*2		; interval data area

DISPDATA:				; LED dot matrix data
;		0000+C3,C2,C1,C0
ROW0:		.DS	1		; row 0 data
ROW1:		.DS	1		; row 1 data
ROW2:		.DS	1		; row 2 data
ROW3:		.DS	1		; row 3 data
ROW4:		.DS	1		; row 4 data
ROW5:		.DS	1		; row 5 data
ROW6:		.DS	1		; row 6 data
ROW7:		.DS	1		; row 7 data


NEXTDATA:	.DS	2		; next PM0 and P0 data



ROWCOUNT:	.DS	1		; next row pointer

PAGECOUNT:	.DS	1		; page counter

SWDATA1:	.DS	1		; last data
SWDATA2:	.DS	1		; last-1 data
SWCHNGE:	.DS	1		; sw is changed
SWPUSH:		.DS	1		; sw is pushed

OKDATA:		.DS	1		; timing is OK
NGDATA:		.DS	1		; timing is NG

TIMECOUNT:	.DS	2		; play time counter(50ms unit)
WDTICOUNT:	.DS	2		; WDTI counter
INTERVAL:	.DS	4		; next ON timing
OKCOUNT:	.DS	2		; count point
RANDCOUNT:	.DS	2
LEDENABLE:	.DS	1
WORKDISPDATA:	.DS	1

PM4IMAGE:	.DS	1		; for P41 display
PM4IMAGEWORK:	.DS	1

BITWORK:	.DS	1		; bit operation
SHIFTENABLE:	.DS	1		; 1: game, 0: wait
SHIFTCOUNT:	.DS	1		; display shift count
MASKDATA:	.DS	1		; mask data for random
ERFLAG:		.DS	1		; NG hit flag(counter)
LEVEL_DT:	.DS	1		; current level
GAME_MODE:	.DS	1		; game mode 0:easy,1:mid,2:hard,3:??
GAME_WORK:	.DS	1		; GAME_MODE*12
SW_PUSH_F2:	.DS	1		; SW pushed accumulate
		.CSEG

IINTWDTI	.VECTOR		0x00004	;(04H) WDTI
IINTTM00	.VECTOR 	0x00012	;(12H) INTTM00
IINTTM01	.VECTOR 	0x00014	;(14H) INTTM01

;****************************************************************
;	for OCD area
;****************************************************************
;.SECTION ocdarea, AT 0x00ce
;        .DB4    0xffffffff
;        .DB4    0xffffffff
;        .DB2    0xffff

XDATA		.CSEG	AT	0x00080
;****************************************************************
;	row select data table
;****************************************************************
R_SELDT:
		.DB	0b00010000	; row0 select
		.DB	0b00100000	; row1 select
		.DB	0b01000000	; row2 select
		.DB	0b10000000	; row3 select
		.DB	0b00010000	; row4 select
		.DB	0b00100000	; row5 select
		.DB	0b01000000	; row6 select
		.DB	0b10000000	; row7 select

;****************************************************************
;	character font table
;****************************************************************
FONT_O:
		.DB	0b00000110
		.DB	0b00001001
		.DB	0b00001001
		.DB	0b00001001
		.DB	0b00001001
		.DB	0b00000110
FONT_K:
		.DB	0b00001000
		.DB	0b00001001
		.DB	0b00001010
		.DB	0b00001100
		.DB	0b00001010
		.DB	0b00001001
FONT_Q:
		.DB	0b00000110
		.DB	0b00001001
		.DB	0b00000010
		.DB	0b00000010
		.DB	0b00000000
		.DB	0b00000010

FONT_E:
		.DB	0b00000110
		.DB	0b00000110
		.DB	0b00000110
		.DB	0b00000110
		.DB	0b00000000
		.DB	0b00000110

FONT_1:
		.DB	0b00000010
		.DB	0b00000110
		.DB	0b00000010
		.DB	0b00000010
		.DB	0b00000010
		.DB	0b00000111

FONT_2:
		.DB	0b00000110
		.DB	0b00001001
		.DB	0b00000001
		.DB	0b00000010
		.DB	0b00000100
		.DB	0b00001111

FONT_3:
		.DB	0b00000110
		.DB	0b00000001
		.DB	0b00000110
		.DB	0b00000001
		.DB	0b00000001
		.DB	0b00000110

FONT_4:
		.DB	0b00000010
		.DB	0b00000110
		.DB	0b00001010
		.DB	0b00001111
		.DB	0b00000010
		.DB	0b00000010


XDATA2		.CSEG
;****************************************************************
;	point table
;****************************************************************
P_TABLE1:
		.DB	0x00		; level 0
		.DB	0x01		; level 1
		.DB	0x02		; level 2
		.DB	0x03		; level 3
		.DB	0x04		; level 4
		.DB	0x05		; level 5
		.DB	0x06		; level 6
		.DB	0x08		; level 7
		.DB	0x0A		; level 8
		.DB	0x0C		; level 9
		.DB	0x10		; level 10
		.DB	0x14		; level 11
P_TABLE2:
		.DB	0x00		; level 0
		.DB	0x01		; level 1
		.DB	0x02		; level 2
		.DB	0x03		; level 3
		.DB	0x05		; level 4
		.DB	0x07		; level 5
		.DB	0x0A		; level 6
		.DB	0x0E		; level 7
		.DB	0x12		; level 8
		.DB	0x16		; level 9
		.DB	0x1C		; level 10
		.DB	0x24		; level 11
P_TABLE3:
		.DB	0x00		; level 0
		.DB	0x01		; level 1
		.DB	0x02		; level 2
		.DB	0x04		; level 3
		.DB	0x08		; level 4
		.DB	0x0C		; level 5
		.DB	0x12		; level 6
		.DB	0x18		; level 7
		.DB	0x20		; level 8
		.DB	0x30		; level 9
		.DB	0x40		; level 10
		.DB	0x60		; level 11

P_TABLE4:
		.DB	0x00		; level 0
		.DB	0x01		; level 1
		.DB	0x02		; level 2
		.DB	0x04		; level 3
		.DB	0x08		; level 4
		.DB	0x0C		; level 5
		.DB	0x12		; level 6
		.DB	0x18		; level 7
		.DB	0x20		; level 8
		.DB	0x30		; level 9
		.DB	0x40		; level 10
		.DB	0x60		; level 11


;****************************************************************
;	level LED display data table
;****************************************************************
LVEL_DISP:
		.DB	0b11111111	; level 0
		.DB	0b11111110	; level 1
		.DB	0b11111101	; level 2
		.DB	0b11111100	; level 3
		.DB	0b11111010	; level 4
		.DB	0b11111000	; level 5
		.DB	0b11110011	; level 6
		.DB	0b11110000	; level 7
		.DB	0b11100111	; level 8
		.DB	0b11100000	; level 9
		.DB	0b11001111	; level 10
		.DB	0b11000000	; level 11

;****************************************************************
;	interval for each level table
;****************************************************************

		.ALIGN	2
LEVEL_NO	.SET	12
DIFF		.SET	TDRDT01*4/5
PITCH		.SET	DIFF/LEVEL_NO
TDR_LV1		.SET	TDRDT01-PITCH
TDR_LV2		.SET	TDR_LV1-PITCH
TDR_LV3		.SET	TDR_LV2-PITCH
TDR_LV4		.SET	TDR_LV3-PITCH
TDR_LV5		.SET	TDR_LV4-PITCH
TDR_LV6		.SET	TDR_LV5-PITCH
TDR_LV7		.SET	TDR_LV6-PITCH
TDR_LV8		.SET	TDR_LV7-PITCH
TDR_LV9		.SET	TDR_LV8-PITCH
TDR_LV10	.SET	TDR_LV9-PITCH
TDR_LV11	.SET	TDR_LV10-PITCH


INTV_TABLE1:
		.DB2	TDRDT01*2	; level 0
		.DB2	TDR_LV1*2	; level 1
		.DB2	TDR_LV2*2	; level 2
		.DB2	TDR_LV3*2	; level 3
		.DB2	TDR_LV4*2	; level 4
		.DB2	TDR_LV5*2	; level 5
		.DB2	TDR_LV6*2	; level 6
		.DB2	TDR_LV7*2	; level 7
		.DB2	TDR_LV8*2	; level 8
		.DB2	TDR_LV9*2	; level 9
		.DB2	TDR_LV10*2	; level 10
		.DB2	TDR_LV11*2	; level 11

INTV_TABLE2:
		.DB2	TDRDT01*3/2	; level 0
		.DB2	TDR_LV1*3/2	; level 1
		.DB2	TDR_LV2*3/2	; level 2
		.DB2	TDR_LV3*3/2	; level 3
		.DB2	TDR_LV4*3/2	; level 4
		.DB2	TDR_LV5*3/2	; level 5
		.DB2	TDR_LV6*3/2	; level 6
		.DB2	TDR_LV7*3/2	; level 7
		.DB2	TDR_LV8*3/2	; level 8
		.DB2	TDR_LV9*3/2	; level 9
		.DB2	TDR_LV10*3/2	; level 10
		.DB2	TDR_LV11*3/2	; level 11

INTV_TABLE3:
		.DB2	TDRDT01*5/4	; level 0
		.DB2	TDR_LV1*5/4	; level 1
		.DB2	TDR_LV2*5/4	; level 2
		.DB2	TDR_LV3*5/4	; level 3
		.DB2	TDR_LV4*5/4	; level 4
		.DB2	TDR_LV5*5/4	; level 5
		.DB2	TDR_LV6*5/4	; level 6
		.DB2	TDR_LV7*5/4	; level 7
		.DB2	TDR_LV8*5/4	; level 8
		.DB2	TDR_LV9*5/4	; level 9
		.DB2	TDR_LV10*5/4	; level 10
		.DB2	TDR_LV11*5/4	; level 11

INTV_TABLE4:
		.DB2	TDRDT01		; level 0
		.DB2	TDR_LV1		; level 1
		.DB2	TDR_LV2		; level 2
		.DB2	TDR_LV3		; level 3
		.DB2	TDR_LV4		; level 4
		.DB2	TDR_LV5		; level 5
		.DB2	TDR_LV6		; level 6
		.DB2	TDR_LV7		; level 7
		.DB2	TDR_LV8		; level 8
		.DB2	TDR_LV9		; level 9
		.DB2	TDR_LV10	; level 10
		.DB2	TDR_LV11	; level 11


XMAIN		.CSEG
;****************************************************************
;								*
;	main function						*
;								*
;****************************************************************
;****************************************************************
main:
;-------------------------------------------------
;	parameter area initialize
;-------------------------------------------------

	MOV	B,	#INTERVAL-DISPDATA
	CLRB	A

MAINLOOP0:
	DEC	B
	MOV	DISPDATA[B],	A	; clear memory
	BNZ	$MAINLOOP0

	MOVW	OKCOUNT,	#0x8000	; clear point
	MOV	NEXTDATA,	#0xFF	; set initial display mode
	MOVW	SWDATA1,	#0xFFFF	; initialize as no SW input
	MOV	SHIFTCOUNT,	#0x20	; initialize shift display counter
	MOV	LEDENABLE,	#0x0F
	MOV	MASKDATA,	#MASKINIT
	CLRB	SHIFTENABLE
	CLRB	ERFLAG
;
;	check RESET source
;
	MOV	A,	RESF		; read reset caused by
	AND	A,	#0b00010000	; check WDTRF
	SKNZ				; skip if time up
	MOVW	PM4IMAGE,	#0xFFFF	; set PM41 not display
	MOV	PAGECOUNT, #SWTIMING	; set next taiming

;
;	start timer
;
	MOV	!TS0,	#0b00000011	; start TM00 and TM01
	CLR1	TMMK00			; enable interrupt
	CLR1	TMMK01			; enable interrupt

	EI				; vector interrupt enable

;************************************************************************
;	wait for start
;************************************************************************
MAINLOOP1:
	MOV	B,	RANDCOUNT
	CALL	!RANDOM
	MOV	INTERVAL,	A
	MOV	B,	A
	INCW	RANDCOUNT
	CALL	!RANDOM
	MOV	INTERVAL+2,	A
	MOV	B,	A
	MOVW	HL,	#MIRLW FONT_O	; set font address
	CALL	!COPY_FONT		; display 'O'
	BNZ	$GAME_START		; branch if SW input
	MOVW	HL,	#MIRLW FONT_K	; set font address
	CALL	!COPY_FONT		; display 'k'
	BNZ	$GAME_START		; branch if SW input
	MOVW	HL,	#MIRLW FONT_Q	; set font address
	CALL	!COPY_FONT		; display '?'
	BZ	$MAINLOOP1		; branch if no SW input
;
;	game start
;
GAME_START:
	MOV	GAME_MODE,	A	; save sw data
	MOV	B,	A
	MOVW	TIMECOUNT,	#0x0000	; clear counter
	MOVW	OKCOUNT,	#0x8000	; clear point
	CALL	!RANDOM
	MOV	INTERVAL+3,	A
	MOV	B,	A
	CALL	!RANDOM
	MOV	INTERVAL+1,	A

	MOV	A,	GAME_MODE	; check SW
	CLRB	GAME_MODE
START_LOOP:
	SHR	A,	1
	BC	$DISP_MODE
	INC	GAME_MODE
	BR	$START_LOOP

DISP_MODE:
	MOV	A,	GAME_MODE
	SHL	A,	2
	MOV	X,	A
	SHL	A,	1
	ADD	A,	X		; *12
	MOV	GAME_WORK,	A
	SHRW	AX,	8
	ADDW	AX,	#MIRLW P_TABLE1	; get level table addr
	MOVW	HL,	AX
	MOV	B,	#12
COPYP_LOOP:				; copy LEVEL data
	DEC	B
	MOV	A,	[HL+B]		; get point data
	MOV	POINTTABLE[B],	A	; copy data
	BNZ	$COPYP_LOOP

;	copy interval data
;
	MOV	A,	GAME_WORK	; get game mode*12
	CLRB	X
	SHRW	AX,	7		; AX: game mode*24
	ADDW	AX,	#MIRLW INTV_TABLE1
	MOVW	HL,	AX
	MOV	B,	#24
COPYI_LOOP:
	DEC	B
	MOV	A,	[HL+B]		; read interval data
	MOV	TM01TABLE[B],	A	; set data
	BNZ	$COPYI_LOOP


;	display game mode

	MOV	A,	GAME_WORK	; game mode *12
	SHRW	AX,	9		; AX:game mode*6
	ADDW	AX,	#MIRLW FONT_1	; get top of font
	MOVW	HL,	AX
	CALL	!COPY_FONT		; display game mode

	CLRB	A
	CLRB	LEVEL_DT
	MOV	B,	#0x08
MAINLOOP2:				; clear display
	DEC	B
	MOV	DISPDATA[B],	A
	BNZ	$MAINLOOP2

	DI
	MOVW	AX,	TM01TABLE
	MOVW	TDR01DATA,	AX	; store new data
	MOV	TDR01H,	A		; set high data for TM01
	MOV	A,	X
	MOV	TDR01L,	A		; set low data for TM01
	EI
	ONEB	SHIFTENABLE		; shift display enable
;
;	start main routine
;
MAIN_LOOP:
	HALT				; wait for interrupt
	NOP

	CMP	LEVEL_DT,	#LEVEL_NO-1
	BC	$MAIN_LOOP              ; loop if continue

	CLRB	SHIFTENABLE		; stop game(stop to shift)
	MOVW	TIMECOUNT,	#0x0000	; clear counter

MAIN_LOOP3:
	MOV	B,	INTERVAL+2
	CALL	!RANDOM
	MOV	INTERVAL+2,	A
	MOVW	HL,	#MIRLW FONT_O	; set font address
	CALL	!COPY_FONT		; display 'O

	MOV	B,	INTERVAL
	CALL	!RANDOM
	MOV	INTERVAL,	A
	MOVW	HL,	#MIRLW FONT_K	; set font address
	CALL	!COPY_FONT		; display 'O

	CLRB	SWPUSH			; clear SW push
	CLRB	OKDATA			; clear OK data
	CLRB	NGDATA			; clear NG data
	CLRB	ERFLAG			; clear ERROR flag
	MOVW	SWDATA1,	#0xFFFF	; initialize as no SW input

	MOVW	HL,	#MIRLW FONT_E	; set font address
	CALL	!COPY_FONT		; display 'O
	BZ	$MAIN_LOOP3		; wait for SW is pushed
RESTART:
	BR	!GAME_START


XMAIN2	.CSEG

;************************************************************************
;
;	TM00 interrupt routine
;
;	row scan and SW check timing
;
;************************************************************************
IINTTM00:
	PUSH	AX
	PUSH	BC
;
;       start next display
;
	CLRB	P0			; clear data
	MOV	PM0,	#0xFF		; disable output
	MOVW	AX,	NEXTDATA	; get next data
	MOV	P0,	A		; set it to P0
	MOV	P4,	A
	MOV	A,	X
	MOV	PM0,	A		; set PM0
	MOV	A,	PM4IMAGE
	ROL	A,	1
	MOV1	PM4.1,	CY
	MOV	PM4IMAGE,	A

;
;	make data for next row
;

	INC	ROWCOUNT		; get next row
	AND	ROWCOUNT,	#0x07	; data is in 3 bit
	BNZ	$IINTTM00NEXT
	DEC	PAGECOUNT
	MOV	A,	PM4IMAGEWORK	; copy level data
	MOV	PM4IMAGE,	A
;
;       preparation for new data
;
IINTTM00NEXT:
	MOV	A,	ROWCOUNT	; get pointer
	MOV	B,	A		; set pointer
	MOV1	CY,	A.2		; check bit2(upper/bottom)
	MOV	X,	#0b00001111	; upper LED

	SKNC
	MOV	X,	#0b11110000	; bottom LED
	
	MOV	A,	DISPDATA[B]	; get display data
	MOV	C,	A
	MOV	A,	MIRLW R_SELDT[B]	; get row select data
	OR	A,	C		; make it one
	XOR	A,	#0xFF		; invert data for PM
	XCH	A,	X
	MOVW	NEXTDATA,	AX	; set next port data

	MOV	A,	ROWCOUNT
	OR	A,	PAGECOUNT	; check key timing
	BNZ	$EXITINTTM00

;
;	50ms timing
;
	MOV	PAGECOUNT, #SWTIMING	; set next timing
	INCW	RANDCOUNT		; for option
	INCW	TIMECOUNT		; play time count
;
;	SW check
;
	MOV	A,	P12		; read SW data
	SHR	A,	1
	MOV1	CY,	P13.7
	MOV1	A.2,	CY		; A.3 <- P13.7
	MOV1	CY,	A.4		; CY <- P12.5
	MOV1	A.3,	CY		; A.2 <- P12.5
	AND	A,	#0x0F
;	0 ,0, 0, 0, P12.5, P13.7, P12.2, P12.1

	XCH	A,	SWDATA1		; save new data
	MOV	SWDATA2, A		; set last-1
	XOR	A,	SWDATA1		; check sw status change
	MOV	SWCHNGE, A		; set change status
	AND	A,	SWDATA2		; get pushed data
	MOV	SWPUSH,	A		; set pushed data
	XCH	A,	SW_PUSH_F2
	OR	A,	SW_PUSH_F2
	XCH	A,	SW_PUSH_F2	; set accumulate SW push flag
	CMP0	SHIFTENABLE		; check shitf flag
	BZ	$EXITINTTM		; exit if not shift
;
;	only when shift mode, check SW is effect
;
	AND	A,	ROW7		; check display data
	MOV	OKDATA,	A		; save success data
	MOV	A,	ROW7
	XOR	A,	#0x0F
	AND	A,	SWPUSH		; get NG push
	MOV	NGDATA,	A		; save NG data
	SKZ
	MOV	ERFLAG,	#0x06
;
;       end of procedure
;
EXITINTTM00:
	CMP	PAGECOUNT, #0x01	; check timing
	BNZ	$EXITINTTM
	MOV	A,	OKDATA		; read OK data
	SHR	A,	1		; check LSB
	MOV	OKDATA,	A
	SKNC
	INCW	OKCOUNT			; if OK then countup
	MOV	A,	NGDATA		; read NG data
	SHR	A,	1
	MOV	NGDATA,	A
	BNC	$EXITINTTM
	DECW	OKCOUNT			; count down 3 when NG 
	CMP	GAME_MODE,	#0x01
	BC	$EXITINTTM		; branch if easy mode
	DECW	OKCOUNT
	SKZ				; skip if midle
	DECW	OKCOUNT

EXITINTTM:
	POP	BC
	POP	AX			; restore AX data
	RETI				; exit from interrupt

;************************************************************************
;
;	TM01 interrupt routine
;
;	change display data timing
;
;************************************************************************
IINTTM01:
	PUSH	AX
	PUSH	BC

	CMP0	SHIFTENABLE
	BZ	$EXITINTTM		; exit if shift off

	EI				; enable multiple interrupt
;
;	shift display routine
;
	MOVW	BC,	#0x0807		; set loop counter
TM01LOOP:
	DEC	B
	DEC	C
	MOV	A,	DISPDATA[C]	; read data
	MOV	DISPDATA[B],	A	; shift it down
	BNZ	$TM01LOOP

;
;	New data generate
;

	MOV	A,	DISPDATA+2	; get row2 data
	XOR	A,	DISPDATA+1	; check change
	AND	A,	DISPDATA+1	; chaneg 0 to 1
	MOV	DISPDATA,	A

;
;	set interval
;
	MOV	B,	#0x04
	CLRB	WORKDISPDATA		; clear initial data
TM01LOOP2:
	MOV	A,	WORKDISPDATA
	SHL	A,	1
	MOV	WORKDISPDATA,	A

	MOV	A,	INTERVAL-1[B]
	SUB	A,	#1
	MOV1	WORKDISPDATA.0,	CY
	SKNC
	CALL	!RANDOM
	MOV	INTERVAL-1[B],	A
	DEC	B
	BNZ	$TM01LOOP2



	MOV	A,	DISPDATA
	OR	A,	WORKDISPDATA
	AND	A,	LEDENABLE	; data mask
	MOV	DISPDATA,	A

	MOVW	AX,	OKCOUNT		; get OK count
	SUBW	AX,	#0x8000		; check point data
	SKNC
	MOVW	AX,	#0x0000		; set 0 for minus
	SHRW	AX,	3		; /8 use only bit3-10

	MOV	B,	#LEVEL_NO-1	; set level number

TM01LOOP3:
	MOV	A,	POINTTABLE-1[B]	; set limit data
	CMP	A,	X		; check level
	DEC	B
	SKC				; skip if enough level
	BNZ	$TM01LOOP3		; loop until level 0
	SKNC
	INC	B			; adjust

;	B : level
	MOV	A,	B
	MOV	LEVEL_DT,	A	; save current level

	MOV	A,	MIRLW LVEL_DISP[B]	; get level display data

	XCH	A,	PM4IMAGEWORK	; set level

;	error blink procedure
	CMP0	ERFLAG
	SKZ
	DEC	ERFLAG
	MOV1	CY,	ERFLAG.0
	NOT1	CY
	MOV1	PM4IMAGEWORK.7,	CY

	SUB	A,	PM4IMAGEWORK
	AND	A,	#0b00111111
;
;	for speed control
;
	BZ	$EXITINTTM
;
;	level change and change interval
;
	SHL	B,	1
	MOVW	AX,	TM01TABLE[B]	; get new data
	MOVW	TDR01DATA,	AX	; store new data
	DI
	MOV	TDR01H,	A		; set high data for TM01
	MOV	A,	X
	MOV	TDR01L,	A		; set low data for TM01

EXITINTTM01:

	BR	!EXITINTTM

;************************************************************************
;
;	WDT interval interrupt routine
;
;	game over timing
;
;************************************************************************
IINTWDTI:
	PUSH	AX
	MOVW	AX,	TIMECOUNT	; get play time data
	CMPW	AX,	#20*60*PLAY_TIME	; play time limit
	BNC	$WAIT_WDT		; exit if time up
	MOV	WDTE,	#0xAC		; clear WDT
	INCW	WDTICOUNT		; count interrupt number
	POP	AX
	RETI
;
;	wait for WDT reset
;
WAIT_WDT:
	BR	$WAIT_WDT

;
;	make random number
;
RANDOM:
	PUSH	PSW
	DI
	MOV	A,	TCR00L
	SHRW	AX,	10
	MOV	A,	TCR00H
	POP	PSW
	SUB	A,	B
	XOR	A,	X
	ADD	A,	RANDCOUNT
	XOR	A,	RANDCOUNT+1
	SUB	A,	OKCOUNT
	AND	A,	MASKDATA
	RET

;
;	copy font data & wait 0.5sec & get SW status
;
; input parameter : font data address in HL
; return value    : Z=1: no SW is pushed
;		  : Z=0: some sw is pushed
;
COPY_FONT:
	MOV	B,	#6
DISPLOOP1:
	DEC	B
	MOV	A,	[HL+B]		; get font data
	MOV	DISPDATA+1[B],	A	; copy data
	BNZ	$DISPLOOP1
	CLRB	DISPDATA
	CLRB	DISPDATA+7

WAIT500MS:
	CLRB	SW_PUSH_F2		; clear SW pushed flag
;
;	wait for 0.5sec
;
	MOVW	TIMECOUNT,	#0x0000	; clear counter
DISPLOOP2:
	CMP	TIMECOUNT,	#15
	BC	$DISPLOOP2
	MOV	A,	SW_PUSH_F2	; get SW pushed flag
	AND	A,	#0x0F		; set flag

	RET

	END

